SystemOrganization addCategory: #ConfigurationOfPharoOnlineHelp!

Object subclass: #ConfigurationOfPharoOnlineHelp
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPharoOnlineHelp'!

!ConfigurationOfPharoOnlineHelp class methodsFor: 'private' stamp: 'tbn 11/6/2012 22:08'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfPharoOnlineHelp class methodsFor: 'private' stamp: 'tbn 11/6/2012 22:08'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfPharoOnlineHelp class methodsFor: 'metacello tool support' stamp: 'tbn 11/6/2012 22:08'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPharoOnlineHelp class methodsFor: 'metacello tool support' stamp: 'tbn 11/6/2012 22:08'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfPharoOnlineHelp class methodsFor: 'loading' stamp: 'tbn 11/6/2012 22:07'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfPharoOnlineHelp class methodsFor: 'metacello tool support' stamp: 'tbn 11/6/2012 22:08'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfPharoOnlineHelp class methodsFor: 'accessing' stamp: 'tbn 11/6/2012 22:07'!
project

	^self new project! !

!ConfigurationOfPharoOnlineHelp methodsFor: 'baselines' stamp: 'tbn 11/6/2012 22:03'!
baseline10: spec
    <version: '1.0-baseline'>
    
    spec for: #common do: [
        spec 
			blessing: #baseline;
			description: '1.0 baseline for Pharo Online Help';
			repository: 'http://ss3.gemstone.com/ss/PharoOnlineHelp'.     
			 
       spec package: 'OnlineHelp'.
				
	 spec
			group: 'all' with: #('OnlineHelp');		
			group: 'default' with: #('OnlineHelp' )
								   
    ]
      
        
! !

!ConfigurationOfPharoOnlineHelp methodsFor: 'accessing' stamp: 'tbn 11/6/2012 22:02'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfPharoOnlineHelp methodsFor: 'symbolic versions' stamp: 'tbn 11/6/2012 22:03'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.! !

!ConfigurationOfPharoOnlineHelp methodsFor: 'versions' stamp: 'tbn 11/6/2012 22:03'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #'release'.	 
		spec description: 'first release'. 
		spec author: 'Torsten Bergmann'.
		spec timestamp: '11/05/2012 22:00'.
		spec package: 'OnlineHelp' with: 'OnlineHelp-tbn.15'.
	]! !
